# =================  マンカラ（Pyhon 対 人） ===========================================================
import tkinter
import random
import time

st1=2      # Python スタート時の皿の番号（0,--,5)
st2=2      # Man スタート時の皿の番号（0,--,5）
x0=0        # スタート時の石の個数 x0=a[st_p] or x0=b[st_m] 
idx=0
tmr=0
key=""
jun=1       # 順番 1(P) or 2(M)
kati=0      # どちらかが勝利で１
z1=0        # Python が次の手番の一手で上がり
z2=0        # Man が次の手番の一手で上がり
ix=0        # デモ表示（１なら本文へ）

a=[0,0,0,0,0,0,0]   # Python             [0] [1] [2] [3] [4] [5]  [6]=pkt_r
b=[0,0,0,0,0,0,0]   # Man     pkt_l=[6]  [5] [4] [3] [2] [1] [0]

# -----------------

def key_down(e):        # Key Down
    global key
    key=e.keysym
def key_up(e):          # Key Up
    global key
    key=""

# ================ 手番１（Python） def ================================================================

def itte_1():    # Python が次の手番の一手で上がるケース => z1=1
    global a,z1,st1
    if a[0]+a[1]+a[2]+a[3]+a[4]==0:
        z1,st1=1,5
    if a[0]+a[1]+a[2]+a[3]==0 and (a[4]==2 or a[4]==9):
        z1,st1=1,4
    if a[0]+a[1]+a[2]==0 and (a[3]==3 or a[3]==10) and (a[4]==1 or a[4]==8):
        z1,st1=1,3
    if a[0]+a[1]==0 and (a[2]==4 or a[2]==11) and (a[3]==2 or a[3]==9) and (a[4]==0 or a[4]==7):
        z1,st1=1,2
    if a[0]+a[1]==0 and (a[2]==4 or a[2]==11) and (a[3]==2 or a[3]==9) and a[4]==2:
        z1,st1=1,4        
    if a[0]==0 and (a[1]==5 or a[1]==12) and (a[2]==3 or a[2]==10) and (a[3]==1 or a[3]==8) and a[4]==6:
        z1,st1=1,1
    if (a[0]==6 or a[0]==13) and (a[1]==4 or a[1]==11) and (a[2]==2 or a[2]==9) and (a[3]==0 or a[3]==7) and a[4]==5:
        z1,st1=1,0
    if (a[0]==6 or a[0]==13) and (a[1]==4 or a[1]==11) and (a[2]==2 or a[2]==9) and a[3]==3 and a[4]==4:
        z1,st1=1,3
        
def itte_2():    # Man が次の手番の一手で上がるケース => z2=1
    global b,z2
    if b[0]+b[1]+b[2]+b[3]+b[4]==0 and b[5]<=8:
        z2=1
    if b[0]+b[1]+b[2]+b[3]==0 and (b[4]==2 or b[4]==9) and b[5]<=8:
        z2=1
    if b[0]+b[1]+b[2]==0 and (b[3]==3 or b[3]==10) and (b[4]==1 or b[4]==8) and b[5]<=8:
        z2=1
    if b[0]+b[1]==0 and (b[2]==4 or b[2]==11) and (b[3]==2 or b[3]==9) and (b[4]==0 or b[4]==2 or b[4]==7) and b[5]<=8:
        z2=1
    if b[0]==0 and (b[1]==5 or b[1]==12) and (b[2]==3 or b[2]==10) and (b[3]==1 or b[3]==8) and b[4]==6 and b[5]<=8:
        z2=1
    if (b[0]==6 or b[0]==13) and (b[1]==4 or b[1]==11) and (b[2]==2 or b[2]==9) and (b[3]==0 or b[3]==7) and b[4]==5 and b[5]<=8:
        z2=1
    if (b[0]==6 or b[0]==13) and (b[1]==4 or b[1]==11) and (b[2]==2 or b[2]==9) and b[3]==3 and b[4]==4 and b[5]<=8:
        z2=1

def safe_1():    # Safe を作る（st1 の決定が後になるほど優先度が高い） 
    global a,s1,st1
    # ----- 二手かかる場合
    if a[5]==0:
        for i in range(0,4):
            if a[i]>=5-i:
                st1=i
    if a[4]==1:
        for i in range(0,3):
            if a[i]>=4-i:
                st1=i
    if a[3]==2:
        for i in range(0,2):
            if a[i]>=3-i:
                st1=i
    if a[2]==3 and a[0]>=2:
        st1=0
    # ----- 一手でできる場合
    if a[5]==1:
        for i in range(0,5):
            if a[i]>=5-i:
                st1=i
    if a[4]==2:
        for i in range(0,4):
            if a[i]>=4-i:
                st1=i
    if a[3]==3:
        for i in range(0,3):
            if a[i]>=3-i:
                st1=i
    if a[2]==4:
        for i in range(0,2):
            if a[i]>=2-i:
                st1=i
    if a[1]==5 and a[0]>=1:
        st1=0

  
def idou_1():    #  Python の石の移動および判定 ------------
    global st1,x0,kati,jun     # st1：スタート時の皿(0--5), x0：石の個数 
    if x0>13-st1:
        for x in range(st1+1,7):
            a[x]+=1
        for x in range(0,7):
            b[x]+=1
        for x in range(0,x0+st1-13):
            a[x]+=1
    else:    
        if x0>6-st1:
            for x in range(st1+1,7):
                a[x]+=1
            for x in range(0,x0+st1-6):
                b[x]+=1
        else:
            for x in range(st1+1,st1+x0+1):     # [
               a[x]+=1
    if a[0]+a[1]+a[2]+a[3]+a[4]+a[5]==0:
        draw_text("勝利！",450,150,40,"red","KATI")         # 表示「勝利！」
        kati=1
    if a[0]>14 or a[1]>14 or a[2]>14 or a[3]>14 or a[4]>14 or a[5]>14:
        draw_text("負け",600,150,40,"blue","KATI")          # 「負け」
        kati=1
    if x0+st1==6 or x0+st1==13:
        draw_text("Hit!",600,170,35,"pink","HIT")         # 表示「ヒット！」
        jun=1
    else:
        jun=2



# ================ 手番２（Man） def ================================================================

def teban_2():
    global st2,x0
    cvs.delete("YA")
    if key=="Left" and st2>=1:     # strt:スタート時の皿の番号 (0,--,5)
        st2=st2-1
    if key=="Right" and st2<=4:
        st2=st2+1
    if key=="Down":
        cvs.delete("HIT")
        st2=5-st2
        x0=b[st2]    # st_m:0,--,5    x0:皿に入っていた石の個数
        if x0>0:
            b[st2]=0      # スタートした皿を空にする
            idou_2()         # ---- 石の移動 -----
        else:
            jun=2   # 個数 0 の皿を↓するとやり直し
        cvs.delete("YA")    
    draw_text("↓",220+150*st2,370,40,"white","YA")
    

def idou_2():    # Man の石の移動および判定  （上の teban_2 の中で）------------
    global st2,x0,kati,jun
    jun=1
    if x0>13-st2:
        for x in range(st2+1,7):
            b[x]+=1
        for x in range(0,7):
            a[x]+=1
        for x in range(0,x0+st2-13):
            b[x]+=1           
    else:    
        if x0>6-st2:
            for x in range(st2+1,7):
                b[x]+=1
            for x in range(0,x0+st2-6):
                a[x]+=1
        else:
            for x in range(st2+1,st2+x0+1):     # [
                b[x]+=1
    st2=5-st2
    if b[0]+b[1]+b[2]+b[3]+b[4]+b[5]==0:
        draw_text("勝利！",750,490,40,"red","KATI")         # 表示「勝利！」
        kati=1
    if b[0]>14 or b[1]>14 or b[2]>14 or b[3]>14 or b[4]>14 or b[5]>14:
        draw_text("負け",600,490,40,"blue","KATI")        # 「負け」
        kati=1
    if x0+5-st2==6 or x0+5-st2==13:
        draw_text("Hit!",600,480,35,"pink","HIT")         # 表示「ヒット！」        
        jun=2
    else:
        jun=1


# ================ 共通  def ================================================================        
        
def draw_isi():      # 現在の a b のリストのデータで全て表示
    cvs.delete("ISI")
    for x in range(0,6):    # a[*]: * * * * * * (0,--,5)
        cvs.create_image(x*150+220,220,image=img_kazu[a[x]],tag="ISI")
    draw_text0(str(a[6]),1110,315,25,"blue","ISI")     # 右箱 a[6]
    for x in range(0,6):    # b[*]: * * * *`* * (5,--,0)
        cvs.create_image(x*150+220,420,image=img_kazu[b[5-x]],tag="ISI")
    draw_text0(str(b[6]),80,315,25,"blue","ISI")       # 左箱 b[6]


def draw_text(txt,x,y,siz,col,tg):      # テキスト表示（影付き）
    fnt=("Times New Roman",siz,"bold")
    cvs.create_text(x+4,y+4,text=txt,fill="black",font=fnt,tag=tg)
    cvs.create_text(x,y,text=txt,fill=col,font=fnt,tag=tg)
    
def draw_text0(txt,x,y,siz,col,tg):      # テキスト表示（影無し）
    fnt=("Times New Roman",siz,"bold")
    #    cvs.create_text(x+3,y+3,text=txt,fill="black",font=fnt,tag=tg)
    cvs.create_text(x,y,text=txt,fill=col,font=fnt,tag=tg)



def main_proc(): # ******************************************************************************************
    global idx,tmr,jun,x0,a,b,st1,st2,z1,z2,kati,ix

    if idx==0:
        if tmr==10:
            tmr=0
            kati=0
            cvs.delete("HIT")
            cvs.delete("KATI")
            cvs.delete("YA")
            jun=1
            st1=2
            st2=2     
            if ix==0:
                ix=1                # これはデモ
                a=[6,4,9,3,4,8,0]           #    -->  a[0] a[1] --- a[5]   a[6]     6,4,2,3,4,*
                b=[4,4,4,4,4,4,0]           #  b[6]   b[5] b[4] --- b[0]  <--
                draw_isi()
                idx=2
            else:                   # ここから本番
                a=[4,4,4,4,4,4,0]
                b=[4,4,4,4,4,4,0]
                draw_isi()
                idx=2
            
# Python 手番（一手ごとにここへ）======================================================================
    # ---------- STEP 1 >>   Python がこの手番で上がれる場合
    elif idx==2:  # 先手：Pyhon 
        if tmr==7:              # まずはこの手番で上がれる場合の処理（ --- => idx=4 ）
            tmr=0
            cvs.delete("HIT")
            if a[5]==8:         # a[5]=8  =>  移動 
                st1=5
                cvs.delete("YA")
                draw_text("↑",220+150*st1,268,40,"white","YA")        
                idx=3
            else:
                idx=4           # a[5]<>8  =>  idx:3  
                
    elif idx==3:                # a[5]=8  のときの処理
        if tmr==5:
            tmr=0
            x0=8
            a[5]=0
            idou_1()            # 判定（勝ち・負け・Hit）          
            draw_isi()
            idx=4

    elif idx==4:                
        if tmr==5:
            tmr=0
            cvs.delete("HIT")
            z1=0
            itte_1()            # この手番で上がれるかをチェック
            if z1==1:           # itte_1() 内に、st1 は指定してある
                cvs.delete("YA")
                draw_text("↑",220+150*st1,268,40,"white","YA")        
                idx=5 
            else:
                idx=10          # 次のステップへ（idx=10）

    elif idx==5:                # この手番で上がり終えるまでの処理
        if tmr==5:
            tmr=0
            x0=a[st1]
            a[st1]=0
            idou_1()            # 判定（勝ち・負け・Hit 
            draw_isi()
            if kati>0:
                idx=45
            else:
                idx=2

    # ------------ STEP 2 >>  Over （自分の方へまわってきてしまう）の処理
    elif idx==10:
        if tmr==5:
            tmr=0
            st1=6
            for i in range(0,6):    # Over が無ければ、st1=6 のまま
                if a[i]>=13-i:
                    st1=i
            if st1==6:          # Over がない 次のステップへ
                idx=15
            else:
                idx=11

    elif idx==11:               # Over の移動
        if tmr==5:
            tmr=0
            x0=a[st1]
            a[st1]=0
            idou_1()            # 判定（勝ち・負け・Hit 
            draw_isi()
            cvs.delete("YA")
            draw_text("↑",220+150*st1,268,40,"white","YA")
            idx=40

    # ----------- STEP 3 >>   Man が次の手番で上がれるかのチェック（ Safe：相手側にまわせる）
    elif idx==15:
        z2=0
        itte_2()
        if z2==1:
            draw_text("注！",370,160,30,"orange","CYU")       # 『注！』 の表示
            idx=16              # Man が次の手番で上がる => Safe を移動 
        else:
            idx=18              # 次の手番で上がらない => STEP 4 （Safe の確保）

    elif idx==16:
        if tmr==5:
            tmr=0
            st1=6
            for i in range(0,6):  # ★★ Safe が無ければ負け！★★
                if a[i]>=7-i:
                    st1=i
            if st1==6:        
                idx=20          # 相手のチョンボを期待して一応手を打つ
            else:
                idx=17

    elif idx==17:               # Safe の移動
        if tmr==5:
            tmr=0
            x0=a[st1]
            a[st1]=0
            idou_1()            # 判定（勝ち・負け・Hit 
            draw_isi()
            cvs.delete("YA")
            draw_text("↑",220+150*st1,268,40,"white","YA")
            idx=40

    # ----------- STEP 4 >>  Man が次の手番では上がらない（ Safe を作ることを目指す）
    elif idx==18:
        st1=6
        for i in range(0,6):
            if a[i]>=7-i:
                st1=i
        if st1<=5:
            idx=25
        else:
            idx=20
            
    elif idx==20:
            st1=6
            safe_1()
            if st1==6:
                idx=25          # Safe を一手、二手で作る目途が立たない => idx=25
            else:
                idx=21

    elif idx==21:               # 一手、二手で Safe を作れるものを移動する
        if tmr==5:
            tmr=0
            x0=a[st1]
            a[st1]=0
            idou_1()            # 判定（勝ち・負け・Hit 
            draw_isi()
            cvs.delete("YA")
            draw_text("↑",220+150*st1,268,40,"white","YA")
            idx=40 

    # ----------- STEP 5 >>  一手、二手で SAfe を作れない。0 個でない皿を左優先で
    elif idx==25: 
        if tmr==5:
            tmr=0
            for i in range(4,-1,-1):  # 左優先 a[0],a[1],---
                if a[i]>0:
                    st1=i
            x0=a[st1]
            a[st1]=0
            idou_1()            # 判定（勝ち・負け・Hit 
            draw_isi()
            cvs.delete("YA")
            draw_text("↑",220+150*st1,268,40,"white","YA")
            idx=40
            
            
# Man 手番 =============================================================================================

    elif idx==30:      # --- 手番２ （移動）------------------
        if tmr==3:
            tmr=0
            cvs.delete("HIT")
            teban_2()
            draw_isi()
#            if kati==2:      # Man の勝利で、kati=2
#                idx=0
#            else:
            idx=40
            
                
# 共通 =================================================================================================

    elif idx==40:
        if tmr==5:
            tmr=0
            cvs.delete("CYU")
            if kati>0:
                idx=45
            else:
                if jun==1:
                    idx=2
                else:
                    idx=30
            cvs.delete("YA")

    elif idx==45:
        if tmr==10:
            tmr=0
            idx=46

    elif idx==46:
        if tmr==3:
            draw_text("Push SPACE",600,320,40,"white","SPACE")
        if tmr==8:
            tmr=0
            cvs.delete("SPACE")
            if key=="space":
                tmr=0
                idx=0
            else:
                idx=46

    tmr=tmr+1
    root.after(90,main_proc)       # root.after 50

# ******************************************************************************************************

root=tkinter.Tk()                       # root=tkinter.Tk()
root.title("マンカラ")
root.bind("<KeyPress>",key_down)        # key_down
root.bind("<KeyRelease>",key_up)        # key_up
cvs=tkinter.Canvas(width=1200,height=650,bg="green")    # Canvas: 1200x650 => cvs
draw_text("マンカラ",600,50,45,"white","TITLE")         # タイトル表示「マンカラ」
draw_text("Python",215,150,40,"white","TITLE")
draw_text("You",1000,490,40,"white","TITLE")
draw_text(">>>",1000,170,30,"white","TITLE")
draw_text("<<<",180,480,30,"white","TITLE")
img_hako2=tkinter.PhotoImage(file="hako_2.png")
cvs.create_rectangle(140,200,1050,250,fill="black")     # 黒い帯＿上
cvs.create_rectangle(140,400,1050,450,fill="black")
cvs.create_image(80,320,image=img_hako2,tag="HAKO")    # 黒い箱＿左
cvs.create_image(1110,320,image=img_hako2,tag="HAKO")
cvs.pack()                
        
img_kazu=[
    tkinter.PhotoImage(file="man_0.png"),  
    tkinter.PhotoImage(file="man_1.png"),  
    tkinter.PhotoImage(file="man_2.png"),  
    tkinter.PhotoImage(file="man_3.png"),
    tkinter.PhotoImage(file="man_4.png"),
    tkinter.PhotoImage(file="man_5.png"),
    tkinter.PhotoImage(file="man_6.png"),
    tkinter.PhotoImage(file="man_7.png"),
    tkinter.PhotoImage(file="man_8.png"),
    tkinter.PhotoImage(file="man_9.png"),
    tkinter.PhotoImage(file="man_10.png"),
    tkinter.PhotoImage(file="man_11.png"),
    tkinter.PhotoImage(file="man_12.png"),
    tkinter.PhotoImage(file="man_13.png"),
    tkinter.PhotoImage(file="man_14.png"),
    tkinter.PhotoImage(file="man_15.png")    
]

main_proc()
root.mainloop()

